<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfMedicalQuestionaire ArrayType
 * @subpackage Arrays
 */
class ArrayOfMedicalQuestionaire extends AbstractStructArrayBase
{
    /**
     * The MedicalQuestionaire
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\MedicalQuestionaire[]
     */
    public $MedicalQuestionaire;
    /**
     * Constructor method for ArrayOfMedicalQuestionaire
     * @uses ArrayOfMedicalQuestionaire::setMedicalQuestionaire()
     * @param \StructType\MedicalQuestionaire[] $medicalQuestionaire
     */
    public function __construct(array $medicalQuestionaire = array())
    {
        $this
            ->setMedicalQuestionaire($medicalQuestionaire);
    }
    /**
     * Get MedicalQuestionaire value
     * @return \StructType\MedicalQuestionaire[]|null
     */
    public function getMedicalQuestionaire()
    {
        return $this->MedicalQuestionaire;
    }
    /**
     * This method is responsible for validating the values passed to the setMedicalQuestionaire method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMedicalQuestionaire method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMedicalQuestionaireForArrayConstraintsFromSetMedicalQuestionaire(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfMedicalQuestionaireMedicalQuestionaireItem) {
            // validation for constraint: itemType
            if (!$arrayOfMedicalQuestionaireMedicalQuestionaireItem instanceof \StructType\MedicalQuestionaire) {
                $invalidValues[] = is_object($arrayOfMedicalQuestionaireMedicalQuestionaireItem) ? get_class($arrayOfMedicalQuestionaireMedicalQuestionaireItem) : sprintf('%s(%s)', gettype($arrayOfMedicalQuestionaireMedicalQuestionaireItem), var_export($arrayOfMedicalQuestionaireMedicalQuestionaireItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The MedicalQuestionaire property can only contain items of type \StructType\MedicalQuestionaire, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set MedicalQuestionaire value
     * @throws \InvalidArgumentException
     * @param \StructType\MedicalQuestionaire[] $medicalQuestionaire
     * @return \ArrayType\ArrayOfMedicalQuestionaire
     */
    public function setMedicalQuestionaire(array $medicalQuestionaire = array())
    {
        // validation for constraint: array
        if ('' !== ($medicalQuestionaireArrayErrorMessage = self::validateMedicalQuestionaireForArrayConstraintsFromSetMedicalQuestionaire($medicalQuestionaire))) {
            throw new \InvalidArgumentException($medicalQuestionaireArrayErrorMessage, __LINE__);
        }
        $this->MedicalQuestionaire = $medicalQuestionaire;
        return $this;
    }
    /**
     * Add item to MedicalQuestionaire value
     * @throws \InvalidArgumentException
     * @param \StructType\MedicalQuestionaire $item
     * @return \ArrayType\ArrayOfMedicalQuestionaire
     */
    public function addToMedicalQuestionaire(\StructType\MedicalQuestionaire $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MedicalQuestionaire) {
            throw new \InvalidArgumentException(sprintf('The MedicalQuestionaire property can only contain items of type \StructType\MedicalQuestionaire, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->MedicalQuestionaire[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\MedicalQuestionaire|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\MedicalQuestionaire|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\MedicalQuestionaire|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\MedicalQuestionaire|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\MedicalQuestionaire|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string MedicalQuestionaire
     */
    public function getAttributeName()
    {
        return 'MedicalQuestionaire';
    }
}
